/*

BusBuddy Test
==============

High-Level tests for includes/busbuddy.h

2019-08-02 Bernhard "HotKey" Slawik

*/

#include <app.h>	// Load all app defines (to re-use the loader's API)
#include <busbuddy.h>	// Load BusBuddy defines

void idle() {
	word t;
	for(t = 0; t < 0x1000; t++) {
		;
	}
}

#define READ_BUFFER_SIZE (BB_BUFFER_SIZE - 8) // Must be smaller than BB_BUFFER_SIZE (64)
int main(int argc, char *argv[]) {
	char c;
	byte b;
	word i;
	byte r;
	byte handle;
	byte l;
	byte buf[READ_BUFFER_SIZE + 1];
	
	(void)argc;	(void)argv;	// Mark args as "not used" to suppress warnings
	
	
	printf("BusBuddy Test\n");
	
	bf_init();
	
	i = 0;
	do {
		printf(">");
		c = getchar();
		printf("%s\n", c);
		
		switch(c) {
			case 'p':
				// Ping
				b = i & 0xff;
				printf("Ping %02X...", b);
				b = bb_ping(b);
				printf("Pong %02X!\n", b);
				
				i++;
				break;
			
			case 's':
				printf("Init SD...");
				r = sd_init();
				if (r == 1)	printf("OK\n");
				else		printf("E=%d\n", r);
				if (r != 1) continue;
				
				//printf("Open file...");
				handle = sd_open("test.txt", BB_FILE_READ);
				//printf("OK\n");
				
				do {
					l = file_read(handle, &buf[0], READ_BUFFER_SIZE);
					buf[l] = 0;	// Zero-terminate
					//printf("%d bytes: ", l);
					//printf("\"%s\"\n", (char *)&buf[0]);
					if (l > 0) printf("%s", (char *)&buf[0]);
				} while (l > 0);
				beep();
				getchar();
				printf("\n");
				
				file_close(handle);
				break;
			
			
			case 'd':
				bb_cmd_asciiz(BB_CMD_DEBUG, "Hello there!");
				break;
			
			case 'a':
				bf_init();
				
				while(1) {
					printf("FF");
					bf_putByte(0xff);
					for(i = 0; i < 0x8000; i++) {;}
					
					printf("00");
					bf_putByte(0x00);
					for(i = 0; i < 0x8000; i++) {;}
				}
				break;
			
			case 'i':
				bf_init();
				while(1) {
					b = bf_getByte();
					printf("%02X", b);
				}
				break;
				
			case 'q':
				// Quit
				break;
			
			default:
				printf("?\n");
		}
		
	} while(c != 'q');
	
	
	return 0;
}


