/*

Loader
======

App loader for V-Tech Genius Leader notebooks.
This program uses "loader.h" to load "apps", link (!) and run them.


2019-07-03 Bernhard "HotKey" Slawik

*/

#include <vgl.h>	// Hardware drivers

#include <stdio.h>
#include <string.h>

#include "loader.h"	// Loader architecture (including API)

#include <hex.h>	// hex dump helpers

void more() {
	//printf("Press any key");
	beep();
	getchar();
	clear();
}


// Include external app(s)
#include "out/app_test.app.h"
#include "out/app_apiTest.app.h"
#include "out/app_hello.app.h"

// Desired destination addresses
const word app_destCode = 0xC800;
const word app_destData = 0xC400;

// Some test arguments
#define MAX_ARGS 8
const char testArg0[7] = "myArg0";
const char testArg1[7] = "myArg1";
char *testArgs[MAX_ARGS];	// = {(char *)testArg0, (char *)testArg1};


// Main cartridge entry point
void main() {
	int r;
	//int i;
	//char s[32];
	
	// Init VGL hardware
	vgl_lcd_init();
	vgl_sound_off();
	
	// Banner
	printf("Loader\n");
	//beep();
	
	
	/*
	printf("Enter something:");
	//scanf("%d", &i); printf("You entered: %d\n", i);
	gets(s); printf("You entered: \"%s\"\n", s);
	*/
	
	
	// Load an app
	clear();
	printf("app_test:\n");
	app_load(APP_TEST, app_destCode, app_destData);
	//printf("addr_start=0x%04X\n", app_addr_start);
	//printf("addr_main=0x%04X\n", app_addr_main);
	//printf("Press key to dump"); getchar(); clear();
	//dump(app_addr_main, 16); printf("\n");
	printf("Press key to start"); getchar(); clear();
	
	//app_callStart();	// Call start() function
	//printf("end.");
	
	//r = app_callMain(0, NULL);	// Call main() function
	testArgs[0] = (char *)&testArg0;
	testArgs[1] = (char *)&testArg1;
	r = app_callMain(2, testArgs);	// Call main() function
	printf("Exit code: %d\n", r);
	getchar();
	
	
	/*
	// Load another app from a different memory region
	clear();
	printf("app_apiTest:\n");
	app_load(APP_APITEST, app_destCode, app_destData);
	
	printf("Press key to start"); getchar(); clear();
	
	//app_callStart();	// Call start() function
	//printf("End.\n");
	
	testArgs[0] = (char *)"Hello";
	testArgs[1] = (char *)"from";
	testArgs[2] = (char *)"args";
	r = app_callMain(3, testArgs);	// Call main() function
	printf("Exit code: %d\n", r);
	getchar();
	*/
	
	
	// Load another app from a different memory region
	clear();
	printf("app_hello:\n");
	app_load(APP_HELLO, app_destCode, app_destData);
	app_callStart();	// Call start() function
	//r = app_callMain(0, NULL);	// Call main() function
	
	
	printf("End of loader. STOP.");
	while(1) {}
	
}
